--print("\134\3* FRIENDMOD, by TyroneSama *") -- no chat message sound pls
print("\134* FRIENDMOD, by TyroneSama *")

local MAXTEAMS = 4

-- documentation for these is in the release post tbh
-- G: but only some of it applies here
local fr_enabled = CV_RegisterVar({
	name = "fr_enabled",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_teams = CV_RegisterVar({
	name = "fr_teams",
	defaultvalue = "2",
	flags = CV_NETVAR,
	possiblevalue = { MIN = 2, MAX = MAXTEAMS }
})
local fr_minplayers = CV_RegisterVar({
	name = "fr_minplayers",
	defaultvalue = "6",
	flags = CV_NETVAR,
	possiblevalue = { MIN = 2, MAX = #players }
})
local fr_teamattack = CV_RegisterVar({
	name = "fr_teamattack",
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_friendlyjawz = CV_RegisterVar({
	name = "fr_friendlyjawz",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_friendlyspb = CV_RegisterVar({
	name = "fr_friendlyspb",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_teamwarning = CV_RegisterVar({
	name = "fr_teamwarning",
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_teamreflect = CV_RegisterVar({
	name = "fr_teamreflect",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_debug = CV_RegisterVar({
	name = "fr_debug",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_crewbattle = CV_RegisterVar({
	name = "fr_crewbattle",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_crewfill = CV_RegisterVar({
	name = "fr_crewfill",
	defaultvalue = "Force",
	flags = CV_NETVAR,
	possiblevalue = { Force = 0, Nomad = 1, Spectate = 2 }
})
local fr_bosschance = CV_RegisterVar({
	name = "fr_bosschance",
	defaultvalue = "0.15",
	flags = CV_FLOAT|CV_NETVAR,
	possiblevalue = { MIN = 0, MAX = FRACUNIT }
})
local fr_onesidename = CV_RegisterVar({
	name = "fr_onesidename",
	defaultvalue = "The World",
	flags = CV_NETVAR
})
local fr_forceboss = CV_RegisterVar({
	name = "fr_forceboss",
	defaultvalue = "Random",
	flags = CV_NETVAR|CV_CALL|CV_NOINIT,
	func = function(cv)
		if cv.string == "Random" then
			CONS_Printf(server, "Disabled forceboss")
		else
			-- don't set anything, just let the server know if a player *will* be found
			local p, c = SG_FindPlayer(cv.string)
			if not p then
				CONS_Printf(server, c and "Bad player number" or "No player matched")
				return
			end
			if c ~= 1 then
				CONS_Printf(server, "Too many players matched")
				return
			end
			CONS_Printf(server, "Setting boss to ["..#p.."] "..SG_Color2Chat[p.skincolor]..p.name)
		end
	end
})
local fr_nopoweritems = CV_RegisterVar({
	name = "fr_nopoweritems",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_bosschoice = CV_RegisterVar({
	name = "fr_bosschoice",
	defaultvalue = "Winner",
	flags = CV_NETVAR,
	possiblevalue = { Winner = 0, Score = 1, Random = 2 }
})

local cvteamcolors = {}
local cvlocalcolors = {}
local cvteamnames = {}
local defaultcolors = { "Blue", "Orange", "Purple", "Lime" }

for i = 1, MAXTEAMS do
	table.insert(cvteamcolors, CV_RegisterVar({
		name = "fr_team"..i.."color",
		defaultvalue = defaultcolors[i],
		flags = CV_NETVAR,
		possiblevalue = SG_CVSkinColors
	}))
	table.insert(cvlocalcolors, CV_RegisterVar({
		name = "fr_team"..i.."colorlocal",
		defaultvalue = "None",
		possiblevalue = SG_CVSkinColors
	}))
	table.insert(cvteamnames, CV_RegisterVar({
		name = "fr_team"..i.."name",
		defaultvalue = "Random",
		flags = CV_NETVAR
	}))
end

local fren = {}
local frteams = {}
addHook("NetVars", function(sync)
	fren = sync($)
	frteams = sync($)
end)

local raceexittime = 5*TICRATE + (2*TICRATE/3)
local starttime = 6*TICRATE + (3*TICRATE/4)
local DRAWONLYFLAGS = MFE_DRAWONLYFORP1 | MFE_DRAWONLYFORP2 | MFE_DRAWONLYFORP3 | MFE_DRAWONLYFORP4
local prettyposition = { [0] = "???", "1st", "2nd", "3rd", [#players-2] = ":|", [#players-1] = ":[", [#players-0] = ">:[" }
for i = 4, #players - 3 do
	prettyposition[i] = tostring(i).."th"
end

COM_AddCommand("fr_changeteam", function(p, team, ...)
	team = tonumber($)
	if not team then
		CONS_Printf(p, "Which team?")
		return
	end

	local q, c = SG_FindPlayer(...)
	if not q then
		CONS_Printf(p, c and "Bad player number" or "No player matched")
		return
	end
	if c ~= 1 then
		CONS_Printf(p, "Too many players matched")
		return
	end

	q.frn.team = team
	CONS_Printf(p, "\131"..q.name.." set to team "..team)
end, COM_ADMIN)

freeslot("SPR_FRIT", "SPR_FRIB") -- bruh...

freeslot( -- allocate sounds
	"sfx_mugen", -- FATAL KO
	"sfx_fatal", -- fatal music
	"sfx_frboss", -- boss announcement
	"sfx_fmssb0", -- generic game mode announcement
	"sfx_fmteam", -- TEAM BATTLE
	"sfx_fmbshc", -- hitconfirm on boss
	"sfx_fmpnch", -- pinch hitconfirm on winning boss
	"sfx_fmstw" -- clutch win: saved the world!
)

local teamnames = {
	[2] = {
		--{"Blue", "Orange", noflip = true},
		{"Coke", "Pepsi"},
		{"Subs", "Dubs"},
		{"Anime", "No Anime"},
		{"Sword", "Drill"},
		{"Super Nintendo", "Genesis"},
		{"Sit", "Stand"},
		{"Right", "Left", noflip = true},
	--	{"Sit", "Stand"},
	--	{":D?", ":D?"},
		{"E", "A"},
		{"Rose", "Chaotix"},
		{"Hero", "Dark"},
	--	{"Slip", "Tide"},
		{"Face", "Trade"},
		{"Rap", "Country"},
		{"Orbi", "Jawz"},
		{"Real", "Ass"},
		{"Synch", "Failure", noflip = true},
	--	{"Sit", "Stand"},
		{"Rust", "Go"},
		{"Tate", "Yoko"},
	--	{"Rust", "Go"},
		{"Lawn", "Mower"},
		{"Tired", "Angry"},
	--	{"A", "1"},
		{"Laser", "Bomb"},
		{"Pad", "Stick"},
		{"Pad", "Keyboard"},
		{"Wifi", "Ethernet"},
		{"Coffee", "Tea"},
		{"Life", "Hometown"},
		{"Adventure", "Boost"},
		{"Wakeup Block", "Wakeup DP"},
		{"Zoners", "Grapplers"},
	--	{"Wario Laughing", "Easy"},
		{"Blazblue", "Guilty Gear"},
		{"98", "2002"},
		{"Treasure", "Platinum"},
		{"ITG", "DDR"},
		{"Pop'N Music", "Beatmania"},
		{"Analog", "Digital"},
		{"Minecraft", "Terraria"},
		{"Capcom", "SNK"},
		{"Capcom", "Marvel"},
		{"Genesis", "Mega Drive"},
		{"GIF with a hard G", "GIF with a soft G"},
		{"PAL", "NTSC"},
		{"FM Towns", "X68000"},
		{"Pride", "Accomplishment"},
		{"Fun", "Glory"},
		{"C64", "Amiga"},
		{"Squid", "Kid"},
		{"Stab", "Stomp"},
		{"Slash", "Bust"},
		{"Advanced", "Extra"},
		{"Cake", "Ice Cream"},
		{"Low", "Overhead"},
		{"Strike", "Throw"},
		{"Hidden Missiles", "Spiral Swords"},
		{"Classic", "Modern"},
		{"Past", "Future"},
		{"Pineapple on pizza", "No pineapple on pizza"},
		{"Shovel", "Shield"},
		{"Ice Clone", "Tom Brady", noflip = true},
		{"Netflix", "Chill"},
		{"Sub-Zero", "Scorpion", noflip = true},
		{"Yanny", "Laurel"},
		{"Black and Blue", "White and Gold", noflip = true},
		{"Alien", "Predator"},
		{"Scoring", "Survival"},
		{"Cave", "Raizing"},
		{"Micrododge", "Macrododge"},
		{"Granblue", "F/GO"},
		{"Puyo Puyo", "Tetris"},
		{"Kancolle", "Azur Lane"},
		{"Light", "Wily"},
		{"Protoman", "Bass"},
		{"CRT", "LCD"},
		{"Melty Blood", "Being Indoors"},
		{"Boxer", "Dictator"},
		{"Gestalt", "Replicant"},
		{"Naruto", "Bleach"},
		{"Katana", "Greatsword"},
		{"Whip", "Spear"},
		{"Dive", "Kick"},
	--	{"Gun", "Also a gun"},
		{"Meat", "Candy"},
		{"Gray", "Grey"},
		{"Gainax", "Trigger"},
		{"Aerowalk", "Facing Worlds"},
		{"Unity", "Unreal"},
		{"Tank", "Healer"},
		{"Heaven", "Hell"},
		{"French Fries", "Onion Rings"},
		{"Hardstyle", "Psytrance"},
		{"Fight", "Flight"},
		{"Bunnyhop", "Strafejump"},
		{"Karin", "Sakura"},
		{"Bound", "Screw"},
		{"Evade", "Parry"},
		{"Square Enix", "PC Ports"},
		{"Crazy", "Stupid"},
	--	{"Tyronesama", "Nullguards"},
	--	{"Tyronesama", "Tyronesama's Microphone"},
	--	{"Tyronesama", "Spatial Relationships"},
		{"Picking Vanilla Lake", "Having a human soul"},
		{"Justice", "Mercy"},
		{":>", ":3"},
		{"Sword Art Online", "Log Horizon"},
		{"Infocom", "Sierra"},
		{"Ryu", "Ken"},
		{"Rei", "Asuka", noflip = true},
		{"Amingo", "Servbot"},
		{"Love Live", "IM@S"},
		{"Atlus", "Good Writing"},
		{"lol", "wwwwwww"},
		{"Beef", "Chicken"},
		{"Tabs", "Spaces"},
		{"Fast", "Furious"},
		{"Seasons", "Ages"},
		{"Alliance", "Horde"},
		{"Hy-dross-ity", "Hydro City"},
		{"Boom", "Tap"},
		{"Software", "OpenGL"},
		{"Race", "Battle"},
	--	{"Melee Community", "Jigglypuff"},
		{"Hungrybox", "A Literal Crab"},
		{"Good music", "Big room"},
		{"East", "West"},
	--	{"Football", "Football"},
		{"258-141", "253-141"},
		{"Milk chocolate", "Dark chocolate"},
		{"Airdash", "Double jump"},
		{"Dual wielding", "Two-handers"},
	--	{"The English Language", "SPECTATOR TO DIE WHY"},
		{"SOKU", "IAMP"},
		{"Gay Energy", "Meme Rectangle"},
		{"Persona 3", "Persona 4"},
		{"Woomy", "Veemo"},
		{"Hope", "Despair"},
		{"Rouge", "Rogue"},
		{"Robot girls", "Sword girls"},
		{"Tekken", "Soulcalibur"},
		{"Goku", "Superman"},
		{"Large", "In charge"},
		{"Ephraim", "Eirika"},
		{"Berserker", "Warrior"},
		{"HORNMOD in hardcode", "HORNMOD in garbage"},
		{"Swordmaster", "Assassin"},
		{"Black Mage", "White Mage"},
		{"Dante", "Donte"},
		{"Kobe", "Yeet"},
		{"Simon", "Richter"},
	--	{"Replay Hut", "Seeding the RNG"}, -- G: fixed since 1.4  future G: but any of the 170 addons on the server can break it
	--	{"im gay", "i've gay"}, No.
		{"Sadu", "Magnai"},
		{"AOSTH", "SATAM"},
		{"Friendmod", "Combiring"},
		{"Sample Text", "Bottom Text"},
		{"Array", "Table"},
		{"Metric", "Freedom"},
		{"Chocolate chip", "Oatmeal raisin"},
		{"VHS", "Betamax"},
		{"Energy Sword", "Gravity Hammer"},
		{"Rybb", "Decker"},
		{"Chex Quest", "Math Blaster"},
		{"Always bet DBZ", "Never bet DBZ"},
		{"Gameplay Integrity", "Gacha Mechanics"},
	--	{":D?", ":D!"},
		{"Chrome", "Firefox"},
		{"UwU", "OwO"},
		{"LMAO", "sdfhjsdfgkdf"},
		{"Chess", "Go"},
		{"Dreamcast", "GameCube"},
		{"Sonic CD (US)", "Sonic CD (JPN)"},
		{"Smogon", "VGC"},
		{"Soda", "Water"},
		{"JPG", "PNG"},
		{"X", "Zero"},
		{"Humanity", "Reploids"},
		{"Sprites", "Models"},
		{"Hornmod 2", "Timely releases"},
		{"Wii U", "Vita"},
		{"Tracker", "Piano roll"},
		{"Honest Neutral", "TK Bad Moon"},
		{"FL Studio", "Ableton"},
		{"Dee", "Vee"},
		{"Player 13", "Actually racing"},
		{"TGM", "Guideline"},
		{"Windia", "Casper"},
		{"Arcade-exclusive shmups", "Ikaruga Again"},
		{"Headphones", "Speakers"},
		{"Aggro", "Control"},
		{"Guitar", "Bass"},
		{"Friendmod", "Hornmod"},
		{"Sound Voltex", "Groove Coaster"},
		{"Robotnik", "Eggman"},
		{"Shortcut Respecters", "Fearless Lawnmowers"},
	--	{"Midnight Channel Classic", "Mayonaka Mk. II"},
	-- Teams below here are custom for Sunflower's Garden. If they suck blame my community members
		{"Football", "Soccer"},
		{"One more", "Stop playing"},
		{"Keyboard", "Controller"},
		{"Vanilla Lake", "Bowser Castle"},
		{"Lightweight", "Heavyweight"},
		{":)", "(:"},
		{"SIGSEG", "SIGSEGV"},
		{"SIGSEGV", "SIGSEV"},
		{"Access violation", "SIGSEGV"},
		{"E-102", "E-123"},
		{"Tails", "Miles"},
		{"Listen server", "Dedicated server"},
		{"Sunflower Garden", "Chao Garden"},
		{"Alpha Chrome", "Google Chrome"},
		{"Ive is nice", "Grip is hip"},
		{"Cream", "Vanilla"},
		{"Vanilla", "Modded"},
		{"Not", "K"},
		{"Documentation", "StackOverflow"},
		{"Leaderboard", "Stattracker"},
		{"EODM", "BDSM"},
		{"sxe", "sex"},
		{"AnimeSonic", "Sunflower"},
		{"Slutoon", "Splatoon"},
		{"Its", "It's"},
		{"Your", "You're"},
		--{"amogus", "Among Us"},
		--{"amogus", "sus"},
		{"Micromachines", "Nanomachines"},
		{"Fracunits", "Hammerunits"},
		{"Fork", "Knife"},
		{"Binary", "Hexadecimal"},
		{"X Y", "Y Of X"},
		{"Pilk", "Lean"},
		{"Quality", "Quantity"},
		{"for loop", "while loop"},
		{"if/else statement", "switch/case statement"},
		{"Google", "Bing"},
		{"Android", "iOS"},
		--{"Windows", "macOS"},
		--{"Windows", "Linux"},
		--{"Windows", "Linux"}, -- lol dupe
		--{"Rock", "Paper"},
		--{"Paper", "Scissors"},
		--{"Scissors", "Rock"},
		{"Discord", "Slack"},
		{"Light mode", "Dark mode"},
		{"Bubblegum", "Bubblecum"},
		{"France", "The World"},
		{"Patafoin", "Diggle"}, -- Nothing personal just banter. Contact me if annoyed though
		{"SRB2kart", "Dr. Robotniks's Ring Racers"},
		{"Kodachrome Void", "Virtual Boy Raceway"},
		{"Reusable", "Not reusable"},
		{"Using chat", "Using clan"},
		{"35 FPS", "Uncapped FPS"},
		{"~", "@"},
		{"Rad", "Rat"},
		{"Woddles", "Woodles"},
		{"Full Screen", "Windowed"},

		-- G: my turn
		{"NES", "Famicom"},
		{"Model 1", "Model 2"},
		{"Sega Rally", "Daytona USA"},
		{"Hang-On", "Out Run"},
		{"Chips", "Crisps"},
		{"Fries", "Chips"},
		{"Laptop", "Desktop"},
		{"Arcade", "Console"},
		{"Game Boy", "Game Gear"},
		{"Invincibility", "Grow"},
		{"Minimap on", "Minimap off"},
		{"Joycons", "Pro Controller"},
		{"Touchpad", "Mouse"},
		{"Banjo", "Kazooie"},
		{"Spectator", "Specator"},
		{"7-Zip", "WinRAR"},
		{"Crab Tank meta", "Tacticooler meta"},
		{"Rumble Pak", "Dualshock"},
		{"Mario", "Luigi"},
		{"Metroid", "Crawling"},
		{"E", "Succ"},
		{"I TOLD YOU", "ABOUT STAIRS"},
		{"Battle bumpers", "No bumpers"},
		{"Crypto", "Cash"}, -- would say "fiat" but that's also a car brand lol
		{"Gay Son", "Thot Daughter"},
		-- New Team Names
		{"Minion", "Da Bob"},
		{"French Bread", "ArcSys"},
		{"Plus Ultra", "Plus Chaos"},
		{"Instagram", "Shannongram"},
	},

	[3] = {
		-- some 2-team names with an extra 3rd name
		-- should the corresponding 2-team names be removed?
		{"PAL", "NTSC", "SECAM"},
		{"Super Nintendo", "Genesis", "PC Engine"},
		{"for loop", "while loop", "repeat loop"},
		{"Keyboard", "Controller", "Wheel"},
		{"Friendmod", "Combiring", "TSR"},
		{"Patafoin", "Diggle", "Kanzaki"},
		{"Puyo Puyo", "Tetris", "Columns"},
		{"CRT", "LCD", "Plasma"},

		-- 2-team names that were duped
		{"Among Us", "amogus", "sus"},
		{"Windows", "macOS", "Linux"},
		{"Rock", "Paper", "Scissors", noflip = true},

		{"Foo", "Bar", "Baz"},
		{"Sonic 1", "Sonic 2", "Sonic 3"}, -- 3D Blast bros...
		{"Virtua Fighter", "Fighting Vipers", "Sonic the Fighters"},
		{"Genesis", "Sega CD", "32X"},
		{"GNOME", "KDE", "Xfce"},
		{"Broke", "Delay", "Limit", noflip = true},
		{"Star Fox", "Starwing", "Lylat Wars"},
		{"Banana", "Triple Banana", "Decabanana"},
		{"rigged", "Alug", "Peco"},
		{"Message Board", "Workshop", "Skybase"},
		{"McDonald's", "Burger King", "Wendy's"},
		{"Crash", "Spyro", "Croc"},
		{"Nvidia", "AMD", "Intel"},
		{"F-Zero", "Wipeout", "Being alive"},
		{"Commodore 64", "Amstrad CPC", "ZX Spectrum"},
		{"Amiga", "Atari ST", "X68000"},
		{"Sonic", "Tails", "Knuckles"},
		{"Game Boy", "Game Gear", "Atari Lynx"},
		{"Pokemon", "Digimon", "Yo-Kai Watch"},
		{"Twitter", "Threads", "Bluesky"},
		{"Video Games", "Video James", "Video Lames"},
		{"Sonic Xtreme", "Sonic Mars", "Sonic Ringworlds"},
		{"Angry Birds Rio", "Angry Birds Space", "Angry Birds Star Wars"},
		{"Nintendo 64", "PlayStation", "Sega Saturn"},
		{"Pokemon Mini", "PocketStation", "VMU"},
		{"kek", "kino", "brap"},
		{"DS", "DSi", "3DS"},
		{"3DS", "New 3DS", "2DS"},
		{"Mario 64", "Mario Sunshine", "Mario Galaxy"},
		{"Composite", "S-Video", "RGB"},
		{"DARRRGH", "NOOO", "STAHP"},
		{"Attack", "Shield", "Grab"},
		{"Spotdodge", "Airdodge", "Roll"},
		--New Names
		{"Setplay", "Strike/Throw", "Grappler"},
	},

	[4] = {
		{"I DONT", "HAVE ENOUGH", "NAMES FOR", "FOUR TEAMS"},
		{"Sweet", "Sour", "Salt", "Bitter"}, -- umami bros...
		{"8-bit", "16-bit", "32-bit", "64-bit"},
		{"Top Left", "Top Right", "Bottom Left", "Bottom Right"},
		{"><", "O/", ":)", "<3"},
		{"NSMB DS", "NSMB Wii", "NSMB 2", "NSMB U"},
		{"STORE", "BURST", "RINGS", "AUGMENT"},
		--New Names
	}
}

local FRtips = {
	{first = "Throw your weight around!", second = "A sacrificial bump can help nearby teammates get ahead."},
	{first = "A poorly-timed Grow can trash your teammates.", second = "Be careful on dash panels and springs!"},
	{first = "Be careful around lightweight teammates.", second = "It doesn't take much to send them into walls!"},
	{first = "Be careful with deployed items.", second = "Deploy while stationary, and you could catch a teammate by surprise!"},
	{first = "Remember to congratulate your teammates on a job well done!", second = ""},
	{first = "If your teammates are holding defensive items, give them some room to set traps.", second = ""},
	{first = "Everyone makes mistakes.", second = "Don't get too upset over it - there's always next round."},
	{first = "The Look Backward button is a powerful tool.", second = "If a teammate has a speed item, make space for them!"},
	{first = "The SPB supercharges 2nd place's items.", second = "Save it to help an ally take the lead!"},
	{first = "When allies are frontrunning, holding the SPB keeps them safe while they pull ahead.", second = ""},
	{first = "Jawz targeting is twitchy and unforgiving.", second = "Keep steady and fire with care!"},
	{first = "See a teammate's Jawz reticle on you?", second = "Pull away from enemies to give them a clear shot."},
	{first = "Don't complain about your team.", second = "Everyone's trying their best."},
	{first = "Always give it your all.", second = "Your team is counting on you!"},
	{first = "Orbinauts travel faster than Jawz.", second = "Use them to save teammates with style!"},
	{first = "The Ball Hog can cause huge collateral damage.", second = "For best results, point-blank an enemy and pray!"},
	{first = "Hyudoro doesn't care what team you're on.", second = "With luck, you can coordinate to smuggle items far ahead..."},
	{first = "Don't hit your allies with the sink.", second = "I know, it's tempting."},
	{first = "Mines laid behind you arm very slowly.", second = "With teammates nearby, it's often safer than throwing them."},
	{first = "When using Invincibility, focusing on enemies can help your allies overtake.", second = ""},
	{first = "Don't be selfish with Invincibility and Grow!", second = "Plowing through allies to save time costs you more than it gains."},
	{first = "Eggbox explosions linger for a long time.", second = "If you have one, pull FAR away from your team!"},
	{first = "Your teammates have an arrow over their heads, no matter what color you are.", second = "Can't tell friend from foe? Type \135config\128 in console to override in-game colors."},
--	{first = "i've gay", second = ""},
	{first = "Bump spinning teammates forward to minimize the damage.", second = ""},
	{first = "Holding 1st and 2nd place nearly guarantees a win.", second = "If you're feeling brave, SPB Rush can help a duo leave everyone behind..."},
	{first = "It's not over until it's over.", second = "Fight until the very end - a single mistake could change everything!"},
	{first = "When you're on track for a shutout, your team score will flash rapidly.", second = "Win without giving up points for a FATAL KO."},
	{first = "There are few things in life like an intense rivalry.", second = "Get friends and foes together for crew battles!"},
	{first = "Overtaking an enemy is worth 2 points, no matter where it happens.", second = "Even if you're far behind, one pass could make a difference."},
	{first = "Be careful with tricky eggbox placement!", second = "If a teammate doesn't see you place it, they might be the one that gets hit..."},
	{first = "Carrying your team? Wish you could ditch the deadweight?", second = "Consistently place high, and you might get your wish..."},
}

-- listen, don't even ask about the way this is formatted, it made sense at the time
-- G: ok
local FRbosstitles = {
	{pre = "Omega "},
	{pre = "Shin "},
	{pre = "Dark "},
	{pre = "Evil "},
	{pre = "Not "},
	{pre = "Gold "},
	{pre = "Serious "},
	{pre = "Literally "},
	{pre = "SSJ3 "},
	{pre = "Awakened "},
	{pre = "Perfect "},
	{pre = "Punished "},
	{pre = "Reformed "},
	{pre = "Activated "},
	{pre = "Devil "},
	{pre = "Orbinaut God "},
	{pre = "Airshot God "},
	{pre = "Palette Swap "},
	{pre = "Violent "},
	{pre = "Rare "},
	{pre = "XF3 "},
	{pre = "Fallen Hero "},
	{pre = "Shirtless "},
	{pre = "Unlimited "},
	{pre = "Revolver "},
	{pre = "Well-Rested "},
	{pre = "Masked "},
	{pre = "Pink Gold "},
	{pre = "Tom Clancy's "},
	{pre = "SD "},
	{pre = "Stylish Mode "},
	{pre = "Lingering "},
	{pre = "K-Groove "},
	--{pre = "Chatbugged "},
	{pre = "Orochi "},
	{pre = "LV. 999 "},
	{pre = "Endless Witch "},
	{pre = "twitch.tv/"},
	{pre = "Gay Pink "},

	{suf = " And Smough"},
	{suf = " With A Gun"},
	{suf = ", The Lonely"},
	{suf = " With Angry Eyebrows"},
	{suf = ", Sniper Extraordinaire"},
	{suf = ", Never Lucky"},
	{suf = ", Unironic Joker Main"},
	{suf = " SP",},
	{suf = " EX",},
	{suf = ", F.O.E!"},
	{suf = " & Knuckles"},
	{suf = "++"},
	{suf = ", Vindicator"},
	{suf = " Prime"},
	{suf = " Black"},
	{suf = ", Edgelord Supreme"},
	{suf = " the Fallen"},
	{suf = " Phase 2"},
	{suf = ", Three Lap Magic"},
	{suf = ", THE ABADDON FIGHTER"},
	{suf = ".EXE"},
	{suf = " After A Balanced Breakfast"},
	{suf = ", WiFi Warrior"},
	{suf = ", A Hideo Kojima Production"},
	{suf = " Platinum"},
	{suf = ", Gamebreaker"},
	{suf = ", Danmaku Legend"},
	{suf = ", Bootshine Hero"},
	{suf = " From Streets"},
	{suf = ", Avatar Of Sorrow"},
	{suf = " 300%"},
	{suf = " (Using Tilt Controls)"},
	{suf = ", Jawzbringer"},
	{suf = "'s Little Sister"},
	{suf = " left the game (Synch Failure)"},

	{pre = "Super ", suf = " II Turbo"},
	{pre = 'Mike "', suf = '" Ross'},
	{pre = 'Ayman "', suf = '" Saria'},
	{pre = "DUDE ", suf = " LMAO"},

	-- G: some stuff
	{pre = "Enraged "},
	{pre = "Legendary "},
	{pre = "Hype "},
	{pre = "Insomniac "},
	{pre = "Slipstreaming "},
	{pre = "Classy "},
	{pre = "Sussy "}, -- i had to
	{pre = "Overclocked "},
	{pre = "Enlightened "},
	{pre = "Hyper-realistic "},
	{pre = "Woke "},
	{pre = "Broke "},
	{pre = "That ain't "},
	{pre = "Betrayed "},
	{pre = "Deranged "},
	{pre = "Synching "},
	{pre = "Cultured "},
	{pre = "Devious "},
	{pre = "Swaggy "},

	{suf = " Squared"},
	{suf = " To the MAX!"},
	{suf = ", Destroyer of Worlds"},
	{suf = ", Enemy of the State"},
	{suf = " Super Deluxe"},
	{suf = " Color"},
	{suf = " Pocket"},
}

local function FRlog(msg, p) -- debug
	if not fr_debug.value then
		return
	end
	print("FRIENDMOD: "..(p and tostring(p.name).." >> " or "")..msg)
end

local function realskincolor(team)
	if team == fren.nomadteam or team == 0 or team > MAXTEAMS then -- cant be assed to fix this
		return SKINCOLOR_GREY
	else
		return cvlocalcolors[team].value or cvteamcolors[team].value
	end
end

local function teamprefix(team)
	if team == fren.nomadteam or team == 0 or team > MAXTEAMS then
		return SG_Color2Chat[SKINCOLOR_GREY]
	else
		return SG_Color2Chat[cvlocalcolors[team].value or cvteamcolors[team].value]
	end
end

rawset(_G, "FRIENDMOD_Teamcolor", realskincolor)
rawset(_G, "FRIENDMOD_Teamprefix", teamprefix)

local function countactive()
	local count = 0
	for p in players.iterate do
		if not p.spectator then
			count = $ + 1
		end
	end
	return count
end

local function playerfinished(p)
	return (p.exiting > 0) or (p.pflags & PF_TIMEOVER) > 0
end

local function findcrew(p)
	for i = 1, #frteams do
		if cvteamnames[i].string == "Random" then continue end

		local matched = string.find(string.lower(p.name), string.lower(cvteamnames[i].string), 1, true)
		if not matched and p.HMclan then
			matched = string.find(string.lower(p.HMclan), string.lower(cvteamnames[i].string), 1, true)
		end

		if matched then
			FRlog("Matched crew "..cvteamnames[i].string, p)
			return i
		end
	end
	FRlog("Did not match a crew", p)
end

local function assignteam(p, team)
	p.frn.team = team
	FRlog("Assigned to team "..p.frn.team, p)
end

local function autoassignteam(p, crew)
	if p.frn.team then
		FRlog("Already assigned a team", p)
		return
	end
	if fren.bossmode then
		FRlog("bossmode lol, go to blue", p)
		assignteam(p, 1)
		return
	end

	if fr_crewbattle.value then
		local team = findcrew(p)
		if team then
			assignteam(p, team)
			return
		end

		-- no crew found
		if fr_crewfill.string == "Nomad" then
			if fren.nomadteam == -1 then
				-- make a team for the nomads
				frteams[#frteams + 1] = {
					name = "The Nomads",
					score = 0,
					pcount = 0,
					finished = 0,
					timeovered = 0,
				}
				fren.nomadteam = #frteams
			end	
			assignteam(p, fren.nomadteam)
			return
		end
		if fr_crewfill.string == "Spectate" and crew then
			p.spectator = true
			chatprintf(p, "\131*Your name or clan did not match any crew names.", true)
			return
		end
	end

	if crew then return end

	-- regular team assignment, pick team with lowest player count
	local count = {}
	for i = 1, #frteams do count[i] = 0 end

	local maxcount = 0
	for p in players.iterate do
		if count[p.frn.team] ~= nil then
			count[p.frn.team] = $ + 1
			maxcount = max($, count[p.frn.team])
		end
	end

	local lowest = 0
	for i = 1, #frteams do
		if count[i] < maxcount then
			lowest = i
		end
	end

	if lowest == 0 then
		FRlog("Team assigned randomly", p)
		assignteam(p, P_RandomRange(1, #frteams))
	else
		FRlog("Team imbalance", p)
		assignteam(p, lowest)
	end
end

local function bossflash()
	fren.bossplayer.kartstuff[k_itemblink] = TICRATE
	fren.bossplayer.kartstuff[k_itemblinkmode] = 2
	S_StartSoundAtVolume(nil, sfx_itrolk, 255, fren.bossplayer)
	S_StartSoundAtVolume(nil, sfx_ruby2, 255, fren.bossplayer)
end

local function doTimeOver(p)
	p.pflags = $ | PF_TIMEOVER
	p.lives = 0
	S_StopSound(p.mo)
	P_DamageMobj(p.mo, nil, nil, 10000)
end

local rollframes = { [0] = B, C, P, D, E, Z, F, G, H, I, J, K, L, M }
local itemframes = { 
	[KITEM_SNEAKER] = B,
	[KITEM_ROCKETSNEAKER] = C,
	[KITEM_INVINCIBILITY] = P,
	[KITEM_BANANA] = D,
	[KITEM_EGGMAN] = E,
	[KITEM_ORBINAUT] = W,
	[KITEM_JAWZ] = F,
	[KITEM_MINE] = G,
	[KITEM_BALLHOG] = H,
	[KITEM_SPB] = I,
	[KITEM_GROW] = J,
	[KITEM_SHRINK] = K,
	[KITEM_THUNDERSHIELD] = L,
	[KITEM_HYUDORO] = M,
	[KITEM_POGOSPRING] = N,
	[KITEM_KITCHENSINK] = O,
}

-- for some dumb reason, most of the overhead logic is disabled outside of battle mode
-- which makes no sense, because... why spawns overheads in the first place then?
addHook("MobjThinker", function(mo)
	if not (fren.doteamstuff and mo.valid) then return end
	-- not spawned by us?
	if mo.flags & MF_SCENERY then
		P_RemoveMobj(mo)
		return
	end

	local pmo = mo.target
	if not (pmo and pmo.player and pmo.player.playerstate ~= PST_DEAD) then
		if mo.tracer then P_RemoveMobj(mo.tracer) end
		if mo.hnext then P_RemoveMobj(mo.hnext); P_RemoveMobj(mo.hprev) end
		P_RemoveMobj(mo)
		return
	end

	local scale = 3*pmo.scale
	mo.color = pmo.player.skincolor

	local z = pmo.z
	if not (pmo.eflags & MFE_VERTICALFLIP) then
		z = z + 24*scale
		mo.eflags = $ & ~MFE_VERTICALFLIP
	else
		z = z - 24*scale - FixedMul(48*FRACUNIT - P_GetPlayerHeight(pmo.player), scale)
		mo.eflags = $ | MFE_VERTICALFLIP
	end
	P_MoveOrigin(mo, pmo.x, pmo.y, z)

	--mo.angle = R_PointToAngle(mo.x, mo.y) + ANGLE_90 // literally only happened because i wanted to ^L^R the SPR_ITEM's -- G: bruh

	if not splitscreen and displayplayers[0].mo then
		-- goofy ahh formatting
		scale = min(16*pmo.scale,
		            pmo.scale + FixedMul(FixedDiv(abs(FixedHypot(displayplayers[0].mo.x - pmo.x,
		                                                  displayplayers[0].mo.y - pmo.y)
                                         ), RING_DIST
                                ), pmo.scale))
	end
	P_SetScale(mo, scale)

	K_MatchGenericExtraFlags(mo, pmo)

	if splitscreen == 0 then
		mo.flags2 = $ | ((pmo.player == displayplayers[0] or pmo.player.frn.team ~= displayplayers[0].frn.team) and MF2_DONTDRAW or 0)
	else
		-- hyuudoro hack: if these are already set after K_MatchGenericExtraFlags, don't draw at all
		if mo.eflags & DRAWONLYFLAGS then
			mo.flags2 = $ | MF2_DONTDRAW
		else
			mo.eflags = $ & ~DRAWONLYFLAGS
			for dp, i in displayplayers.iterate do
				if dp.frn.team == pmo.player.frn.team and dp ~= pmo.player then
					mo.eflags = $ | (MFE_DRAWONLYFORP1 << i)
				end
			end
			-- if none of the drawonlyfor flags are set, it will show for every player. hide it
			if not (mo.eflags & DRAWONLYFLAGS) then
				mo.flags2 = $ | MF2_DONTDRAW
			end
		end
	end

	// Set it to use the correct states for its condition
	local itype = pmo.player.kartstuff[k_itemtype]
	local framenum = 0
	local hide = 0

	if pmo.player.kartstuff[k_itemroulette] then
		-- leveltime instead of k_itemroulette
		-- thank you xitemlib
		framenum = rollframes[(leveltime % (13*3)) / 3]
	elseif pmo.player.kartstuff[k_stolentimer] > 0 then
		framenum = M
		hide = leveltime & 2
	elseif pmo.player.kartstuff[k_stealingtimer] > 0 then
		framenum = M
		hide = leveltime & 2
	elseif pmo.player.kartstuff[k_eggmanexplode] > 1 then
		framenum = E
		hide = leveltime & 1
	elseif pmo.player.kartstuff[k_rocketsneakertimer] > 1 then
		//itembar = pmo.player.kartstuff[k_rocketsneakertimer] // not today satan
		framenum = C
		hide = leveltime & 1
	elseif pmo.player.kartstuff[k_growshrinktimer] > 0 then
		framenum = J
		hide = leveltime & 1
	elseif pmo.player.kartstuff[k_sadtimer] > 0 then
		framenum = A
		hide = leveltime & 2
	elseif itype and pmo.player.kartstuff[k_itemamount] > 0 then
		if itype == KITEM_ORBINAUT then
			framenum = min(V + pmo.player.kartstuff[k_itemamount], Z)
		elseif itype == KITEM_INVINCIBILITY then
			framenum = P + ((leveltime % (7*3)) / 3)
		else
			framenum = (itemframes[itype] or A)
		end

		hide = pmo.player.kartstuff[k_itemheld] and leveltime & 1
	end

	local zoffs = 11*scale
	if mo.eflags & MFE_VERTICALFLIP then zoffs = -zoffs + 5*scale - P_GetPlayerHeight(pmo.player)*2 end

	if framenum then
		if not mo.tracer then
			mo.tracer = P_SpawnMobj(mo.x, mo.y, mo.z + zoffs, MT_THOK)
			mo.tracer.flags = $ | MF_NOTHINK -- become stupid
			mo.state = S_PLAYERARROW_BOX
		end
		local icon = mo.tracer
		P_SetScale(icon, scale)
		K_MatchGenericExtraFlags(icon, mo)
		P_MoveOrigin(icon, mo.x, mo.y, mo.z + zoffs)

		// Do this in an easy way
		if pmo.player.kartstuff[k_itemroulette] then
			icon.color = pmo.player.skincolor
			icon.colorized = true
		else
			icon.color = SKINCOLOR_NONE
			icon.colorized = false
		end

		icon.sprite = SPR_FRIT
		icon.frame = FF_FULLBRIGHT | framenum
		icon.flags = ($ & ~MF2_DONTDRAW) | (hide * MF2_DONTDRAW)
		if pmo.player.kartstuff[k_itemblink] and not (leveltime & 1) then
			icon.sprite = SPR_FRIB
			if pmo.player.kartstuff[k_itemblinkmode] == 2 then
				icon.color = 1 + (leveltime % (MAXSKINCOLORS-1))
			elseif pmo.player.kartstuff[k_itemblinkmode] == 1 then
				icon.color = SKINCOLOR_RED
			else
				icon.color = SKINCOLOR_WHITE
			end
		end
	elseif mo.tracer then
		P_RemoveMobj(mo.tracer)
		mo.state = S_PLAYERARROW
	end

	if pmo.player.kartstuff[k_itemamount] > (itype == KITEM_ORBINAUT and 4 or 1) then
		if not mo.hnext then
			mo.hnext = P_SpawnMobj(mo.x, mo.y, mo.z + zoffs, MT_THOK)
			mo.hnext.flags = $ | MF_NOTHINK
			mo.hnext.state = S_PLAYERARROW_NUMBER

			mo.hprev = P_SpawnMobj(mo.x, mo.y, mo.z + zoffs, MT_THOK)
			mo.hprev.flags = $ | MF_NOTHINK
			mo.hprev.state = S_PLAYERARROW_X
		end

		local number = mo.hnext
		local numx = mo.hprev

		number.frame = FF_FULLBRIGHT | min(11, pmo.player.kartstuff[k_itemamount])
		P_SetScale(number, scale)
		K_MatchGenericExtraFlags(number, mo)
		P_MoveOrigin(number, mo.x, mo.y, mo.z + zoffs)

		P_SetScale(numx, scale)
		K_MatchGenericExtraFlags(numx, mo)
		P_MoveOrigin(numx, mo.x, mo.y, mo.z + zoffs)
	elseif mo.hnext then
		P_RemoveMobj(mo.hnext)
		P_RemoveMobj(mo.hprev)
	end
end, MT_PLAYERARROW)

addHook("MobjThinker", function(mo)
	if not (fren.doteamstuff and mo.valid) then return end
	-- not spawned by us?
	if mo.flags & MF_SCENERY then
		P_RemoveMobj(mo)
		return
	end

	local pmo = mo.target
	if pmo and pmo.player and pmo.playerstate ~= PST_DEAD then
		K_MatchGenericExtraFlags(mo, pmo)

		mo.color = (leveltime % 6) < 3 and SKINCOLOR_CRIMSON or SKINCOLOR_WHITE

		if splitscreen == 0 then
			if mo.target.player == displayplayers[0] then
				mo.frame = $ & ~FF_TRANSMASK
				local trans = max(0, (leveltime - 3*TICRATE) * FF_TRANS10)
				if trans > FF_TRANS90 then
					mo.flags2 = MF2_DONTDRAW
				elseif trans then
					mo.frame = $ | trans
					mo.tics = 2
				end
			end
		else
			if mo.eflags & DRAWONLYFLAGS then -- hyuudoro hack
				mo.flags2 = $ | MF2_DONTDRAW
				return -- MF2_DONTDRAW overrides per-view flags anyway
			end
			mo.eflags = $ | DRAWONLYFLAGS
			for dp, i in displayplayers.iterate do
				if dp == fren.bossplayer then mo.eflags = $ & ~(MFE_DRAWONLYFORP1 << i) end
			end
		end

		if not (pmo.eflags & MFE_VERTICALFLIP) then
			mo.z = pmo.z + P_GetPlayerHeight(pmo.player) + (16*pmo.scale)
			mo.eflags = $ & ~MFE_VERTICALFLIP
		else
			mo.z = pmo.z - P_GetPlayerHeight(pmo.player) - (16*pmo.scale)
			mo.eflags = $ | MFE_VERTICALFLIP
		end

		P_MoveOrigin(mo, pmo.x, pmo.y, mo.z)
	else
		P_RemoveMobj(mo)
	end
end, MT_PLAYERWANTED)

local function FYShuffle(tInput)
	local tReturn = {}
	for i = #tInput, 1, -1 do
		local j = P_RandomRange(1, i)
		tInput[i], tInput[j] = tInput[j], tInput[i]
		table.insert(tReturn, tInput[i])
	end
	return tReturn
end

local function SpawnOverhead(p)
	if p == fren.bossplayer then
		-- INT32_MIN???
		-- yeah, can't be assed to copy-paste the z offset code
		local wanted = P_SpawnMobj(p.mo.x, p.mo.y, INT32_MIN, MT_PLAYERWANTED)
		wanted.target = p.mo
		wanted.colorized = true
		wanted.health = 0
		wanted.flags = $ & ~MF_SCENERY
	else
		local overhead = P_SpawnMobj(p.mo.x, p.mo.y, INT32_MIN, MT_PLAYERARROW)
		overhead.target = p.mo
		overhead.flags = $ & ~MF_SCENERY
		overhead.xitem_no_replace = true -- thank you xitemlib
	end
end

local function InitPlayer(p)
	p.frn = {
		team = 0,
		teamattacked = 0,
		killscore = 0,
		personalscore = 0,
		lastframeitem = 0,
		finished = false,
	}
end

local function calculateScore()
	for _, team in pairs(frteams) do team.score = 0 end
	local highestscore, leader = -1, nil

	for p in players.iterate do
		if p.spectator or (p.pflags & PF_TIMEOVER) then continue end

		-- calculate score
		if G_RaceGametype() then
			p.frn.personalscore = 0
			local tiedfirst = false
			for q in players.iterate do
				if not q.spectator and p ~= q then
					if q.kartstuff[k_position] == 1 then
						tiedfirst = true
					end
					if p.frn.team ~= q.frn.team and p.kartstuff[k_position] < q.kartstuff[k_position] then
						p.frn.personalscore = $ + 2
					end
				end
			end
			if p.kartstuff[k_position] == 1 and not tiedfirst then
				p.frn.personalscore = $ + 1
				leader = p
			elseif p == fren.bossplayer then
				p.frn.personalscore = min($, 1) -- don't fatal KO boss if they finish 2nd
			end
		else
			if fren.battletype == 1 then
				p.frn.personalscore = p.marescore + (not fren.nobumpers and p.kartstuff[k_bumper] * 2 or 0)
			else
				p.frn.personalscore = p.kartstuff[k_bumper]
			end

			if p.frn.personalscore > highestscore then
				highestscore = p.frn.personalscore
				leader = p
			end
		end

		frteams[p.frn.team].score = $ + p.frn.personalscore
	end

	return leader
end

addHook("IntermissionThinker", do
	if fren.restorecolors and fren.doteamstuff then
		fren.restorecolors = false
		local colorvars = { CV_FindVar("color"), CV_FindVar("color2"), CV_FindVar("color3"), CV_FindVar("color4") }
		for _, cv in pairs(colorvars) do
			if cv then CV_Set(cv, cv.value) end
		end
	end
end)

addHook("MapChange", function()
	local wasenabled = false
	if fren then
		if fren.gameover then hud.enable("battlefullscreen") end
		if fren.doteamstuff then wasenabled = true end
	end

	fren = {
		doteamstuff = false, -- enabled
		savedtheworld = false, -- should we do special celebrations for 1 player beating a boss, or leader bonus deciding a normal teams game?
		bossgotemname = "", -- who last nailed the boss?
		gameover = false, -- have we locked in final scores?
		bossgotemposition = 0, -- where was the boss when they got hit?
		bossgotemtime = 0, -- timestamp for ghetto boss killfeed
		fatalko = false, -- last team with zero score gets blown up
		blowout = false, -- blown up everyone yet?
		restorecolors = false, -- have we written colors back to teams-mode players during intermission yet? (gotta preserve personal colors for mixed games)
		helpfuladvice = 0, -- random index for postrace tips
		dobossprotect = false, -- is the boss receiving a pity item after a hit?
		dobossrestock = false, -- whether boss should be given bonus item stock (true unless they've already received it for this pull)
		bossplayer = false, -- gotta keep track of who the boss is to apply boss-specific mechanics
		bossmode = false, -- like a boss?
		battletype = 0, -- used for different messages in battle mode
		nobumpers = 0, -- nobumpers active
		bossfocused = fren.bossfocused or "", -- the player currently being watched for boss selection; if fr_bosschance = 1 this makes them unpickable, if fr_bosschance < 1 it forces them to be picked
		teamsfinished = 0, -- number of finished teams
		winningteam = -1, -- currently winning team
		nomadteam = -1, -- team number for nomad team in crew battle
	}

	fren.restorecolors = wasenabled

	setmetatable(fren, {
		__index = function() error("No peeking", 2) end,
		__newindex = function() error("No touchy", 2) end,
	})

	frteams = {}
	for i = 1, fr_teams.value do
		frteams[i] = {
			name = "WTF",
			score = 0,
			pcount = 0,
			finished = 0,
			timeovered = 0,
		}
		setmetatable(frteams[i], {
			__index = function() error("No peeking", 2) end,
			__newindex = function() error("No touchy", 2) end,
		})
	end
end)

local xitemhooked = false

addHook("MapLoad", function()
	if xItemLib and not xitemhooked then
		-- i hate to take up arms like this but xitemlib ain't cooperating
		xitemhooked = true
		addHook("MobjThinker", function(mo)
			if fren.doteamstuff then
				FRlog("thank you xitemlib")
				mo.fuse = 1
			end
		end, MT_XITEMPLAYERARROW)
	end

	if fr_enabled.value then
		fren.doteamstuff = true
		if (countactive() < fr_minplayers.value) then
			FRlog("Teams force disabled, not enough players")
			fren.doteamstuff = false
		end
	end

	rawset(_G, "FRIENDMOD_Active", fren.doteamstuff)
	if not fren.doteamstuff then
		if fren.restorecolors then
			fren.restorecolors = false
			local colorvars = { CV_FindVar("color"), CV_FindVar("color2"), CV_FindVar("color3"), CV_FindVar("color4") }
			for _, cv in pairs(colorvars) do
				if cv then CV_Set(cv, cv.value) end
			end
		end
		return
	end

	fren.restorecolors = true
	fren.bossfocused = SG_Archive($)
	fren.helpfuladvice = P_RandomRange(1, #FRtips)

	-- pick team names
	local pick = teamnames[#frteams][P_RandomRange(1, #teamnames[#frteams])]
	for i = 1, #pick do
		frteams[i].name = "Team "..pick[i]
	end
	if not pick.noflip then frteams[1].name, frteams[2].name = $2, $1 end

	-- do name overrides
	for i = 1, #frteams do
		frteams[i].name = cvteamnames[i].string ~= "Random" and cvteamnames[i].string or $
	end

	local shuffledplayers = {}
	for p in players.iterate do
		InitPlayer(p)
		if not p.spectator then
			table.insert(shuffledplayers, p)
		end
	end
	shuffledplayers = FYShuffle(shuffledplayers)

	if not fr_crewbattle.value and P_RandomRange(1, FRACUNIT-1) < fr_bosschance.value then
		-- it's bossin' time
		fren.bossmode = true

		-- we only need two teams for this
		for i = 3, #frteams do
			frteams[i] = nil
		end
		frteams[1].name = fr_onesidename.string

		if fr_forceboss.string ~= "Random" then
			local p, c = SG_FindPlayer(fr_forceboss.string)
			if p and c == 1 then
				FRlog("Forceboss set, checking name against "..p.name)
				fren.bossfocused = p.name
			else
				FRlog("Forceboss not found")
			end
		end

		for _, v in ipairs(shuffledplayers) do
			if v.name == fren.bossfocused then
				FRlog("Promoting to boss", v)
				fren.bossplayer = v
				break
			end
		end

		if not fren.bossplayer then
			fren.bossplayer = shuffledplayers[P_RandomRange(1, #shuffledplayers)]
			FRlog("No boss was picked, going random", fren.bossplayer)
		end

		local bosstitle = P_RandomRange(1, #FRbosstitles)
		frteams[2].name = (FRbosstitles[bosstitle].pre or "")..fren.bossplayer.name..(FRbosstitles[bosstitle].suf or "")
		assignteam(fren.bossplayer, 2)
		fren.bossfocused = ""

		for _, v in ipairs(shuffledplayers) do
			if v ~= fren.bossplayer then assignteam(v, 1) end
		end
	else
		FRlog("Assigning teams from shuffle")
		if fr_crewbattle.value then
			-- crew players first
			for _, v in ipairs(shuffledplayers) do
				autoassignteam(v, true)
			end
		end

		for _, v in ipairs(shuffledplayers) do
			autoassignteam(v)
		end
	end

	if G_BattleGametype() then
		local hm_timelimit = CV_FindVar("hm_timelimit")
		local timelimit = CV_FindVar("timelimit")
		local pointlimit = CV_FindVar("pointlimit")
		if (hm_timelimit and hm_timelimit.value > 0) or (timelimit and timelimit.value > 0) or (pointlimit and pointlimit.value > 0) then
			-- fight for points
			fren.battletype = 1
		else
			-- stay alive
			fren.battletype = 2
		end
		fren.nobumpers = G_NoBumperBattleGametype()
	end

	for p in players.iterate do
		if p.spectator then continue end
		SpawnOverhead(p)

		if G_BattleGametype() and fren.bossmode and p == fren.bossplayer then
			-- give the boss a shitload of bumpers
			local bossbumpers = countactive() * 2
			local oldbumpers = p.kartstuff[k_bumper]
			if bossbumpers < oldbumpers then continue end

			p.kartstuff[k_bumper] = bossbumpers

			-- gotta spawn the extra bumpers now...
			for i = oldbumpers, bossbumpers - 1 do
				local mo = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_BATTLEBUMPER)
				mo.threshold = i
				mo.target = p.mo
				mo.color = p.mo.color
				if p.mo.flags2 & MF2_DONTDRAW then
					mo.flags2 = $ | MF2_DONTDRAW
				else
					mo.flags2 = $ & ~MF2_DONTDRAW
				end
			end
		end
	end
end)

local function EndRace()
	K_SetExitCountdown(10*TICRATE)
	fren.gameover = true
	hud.disable("battlefullscreen")

	FRlog("finish")

	-- pick next game's boss
	if fr_bosschoice.string == "Winner" then
		for p in players.iterate do
			if not p.spectator and p.kartstuff[k_position] == 1 then
				fren.bossfocused = p.name
				break
			end
		end
	elseif fr_bosschoice.string == "Score" then
		local highest = 0
		for p in players.iterate do
			if not p.spectator and p.score > highest then
				fren.bossfocused = p.name
				highest = p.score
			end
		end
	end

	for p in players.iterate do
		if p.spectator then continue end
		p.frn.finished = true
		p.exiting = raceexittime + 2 -- don't exit via exiting, use exitcountdown (yeah, totally not confusing...)
	end

	local leader = calculateScore()

	-- blow up boss for losing
	if fren.bossmode and fren.bossplayer and fren.winningteam ~= 2 then
		FRlog("BAKOOM")
		fren.bossplayer.exiting = 0 -- else damage doesn't go through
		doTimeOver(fren.bossplayer)
		fren.bossplayer.exiting = 1
	end

	-- clutch?
	local scores = {}
	for k, team in pairs(frteams) do
		scores[k] = team.score
	end
	table.sort(scores, function(a, b) return a > b end)
	if fren.bossplayer and fren.bossplayer.kartstuff[k_position] == 2 or abs(scores[1] - scores[2]) == 1 then
		FRlog("Leader", leader)
		if leader and leader ~= fren.bossplayer and leader.frn.team == fren.winningteam then
			fren.savedtheworld = leader
		end
	end

	if fren.fatalko then
		FRlog("fatal ko sound")
		S_ChangeMusic("fatal", false)
		S_StartSoundAtVolume(nil, sfx_mugen, 255)
	elseif fren.bossmode and fren.winningteam == 2 then
		FRlog("boss win sound")
		S_ChangeMusic("frover", false, p)
	elseif fren.savedtheworld then
		FRlog("STW sound")
		S_ChangeMusic("fmstw", false, p)
	else
		for p in players.iterate do
			if p.spectator or p.frn.team == fren.winningteam then
				p.marescore = 1
				FRlog("kbwin time", p)
				S_ChangeMusic("kbwin", false, p)
			elseif fren.winningteam == 0 then -- tied
				p.marescore = 1
				FRlog("what does this even count as", p)
				S_ChangeMusic("fmdblk", false, p)
			else
				p.marescore = 0
				FRlog("kblose time", p)
				S_ChangeMusic("kblose", false, p)
			end
		end
	end
end

local function ExitRace()
	FRlog("exiting")
	for p in players.iterate do
		if not p.spectator and p.frn.finished then
			FRlog("scoreboard set", p)
			p.pflags = $ & (~PF_TIMEOVER)
			p.marescore = p.frn.personalscore
			if p.frn.team == fren.winningteam then
				FRlog("Last chance win setup", p)
				if not fren.fatalko then
					FRlog("win music change", p)
					S_ChangeMusic("krwin", true, p)
				end
			elseif fren.winningteam == 0 then -- tied
				FRlog("Last chance tie?", p)
				if not fren.fatalko then
					FRlog("win music change", p)
					S_ChangeMusic("krwin", true, p)
				end
			else
				FRlog("Last chance loss setup", p)
				p.pflags = $ | PF_TIMEOVER
				if not fren.fatalko then
					FRlog("loss music change", p)
					S_ChangeMusic("krlose", true, p)
				end
			end
		end
	end
end

local function doBlowout(team)
	FRlog("Team "..team.." blowout!")
	fren.blowout = true
	if not (fren.bossmode and team == 1) then fren.fatalko = true end
	for p in players.iterate do
		if not p.spectator and p.frn.team == team and not (p.pflags & PF_TIMEOVER) then
			FRlog("blowout die", p)
			doTimeOver(p)
		end
	end
end

-- hoo boy, this team attack stuff sure is messy...
-- good thing this is only needed if teamattack is off
local function addTeamAttackHooks()
	FRlog("Hooking team attack")

	-- ignore explosions and squishes
	local function ShouldTeamAttack(target, _, source)
		if fren.doteamstuff and not fr_teamattack.value
		and source and source.player and target ~= source.player
		and target.frn.team == source.player.frn.team then
			FRlog("Type 1 parry", target)
			K_DoInstashield(target)
			return false
		end
	end

	addHook("ShouldSquish", ShouldTeamAttack)
	addHook("ShouldExplode", ShouldTeamAttack)

	-- a shitload of hooks to phase through friendly items
	local parryitems = {MT_EGGMANITEM, MT_BANANA, MT_ORBINAUT, MT_JAWZ, MT_JAWZ_DUD, MT_SSMINE, MT_BALLHOG, MT_SPB, MT_EGGMANITEM_SHIELD, MT_BANANA_SHIELD, MT_ORBINAUT_SHIELD, MT_JAWZ_SHIELD, MT_SSMINE_SHIELD}
	for _, v in pairs(parryitems) do
		addHook("MobjCollide", function(item, mo)
			if fren.doteamstuff and not fr_teamattack.value
			and item.target and mo.player
			and mo.z + mo.height >= item.z and mo.z <= item.z + item.height
			and item.target ~= mo
			and item.target.player.frn.team == mo.player.frn.team then
				FRlog("Type 2 parry", mo.player)
				K_DoInstashield(mo.player)
				return false
			end
		end, v)
		addHook("MobjMoveCollide", function(item, mo)
			if fren.doteamstuff and not fr_teamattack.value
			and item.target and mo.player
			and mo.z + mo.height >= item.z and mo.z <= item.z + item.height
			and item.target ~= mo
			and item.target.player.frn.team == mo.player.frn.team then
				FRlog("Type 3 parry", mo.player)
				K_DoInstashield(mo.player)
				return false
			end
		end, v)
		addHook("MobjThinker", function(mo)
			if fren.doteamstuff and mo.valid then
				mo.flags2 = $ & ~MF2_SHADOW
				mo.eflags = $ | DRAWONLYFLAGS
				if not fr_teamattack.value and mo.target and mo.target.player then
					if splitscreen == 0 then
						mo.flags2 = $ | ((mo.target.player ~= displayplayers[0] and mo.target.player.frn.team == displayplayers[0].frn.team) and MF2_SHADOW or 0)
					elseif leveltime & 1 then
						-- on splitscreen, we don't have the privilege of setting MF2_SHADOW per view
						-- so instead, flash the item for each player
						for dp, i in displayplayers.iterate do
							if mo.target.player.frn.team == dp.frn.team and mo.target.player ~= dp then
								mo.eflags = $ & ~(MFE_DRAWONLYFORP1 << i)
							end
						end
					end
				end
			end
		end, v)
	end

	-- some special logic for invinc and bumper stealing
	-- wish i could just hook ShouldSpin or MobjDamage or something, and not tank performance...
	local function teamAttackCollide(source, target)
		if fren.doteamstuff and not fr_teamattack.value
		and target.player
		and target.z + target.height >= source.z and target.z <= source.z + source.height
		and (source.player.kartstuff[k_invincibilitytimer] or (G_BattleGametype() and (source.player.kartstuff[k_sneakertimer] or source.player.kartstuff[k_pogospring] and source.momz < 0)))
		and source.player.frn.team == target.player.frn.team then
			FRlog("Type 4 parry", target.player)
			K_DoInstashield(target.player)
			return false
		end
	end
		
	addHook("MobjCollide", teamAttackCollide, MT_PLAYER)
	addHook("MobjMoveCollide", teamAttackCollide, MT_PLAYER)
end

-- extra hooks for friendly items
local reticles = {}
local function addJawzHooks()
	FRlog("Hooking Jawz")
	-- reticules are spawned in P_PlayerAfterThink, after all mobjthinkers have already run
	-- we only have half a tic here to decide wheter this reticle should be rendered or not,
	-- so save it in a table and let our ThinkFrame hook decide
	addHook("MobjSpawn", function(mo)
		if fren.doteamstuff and (fr_friendlyjawz.value or (not fr_teamattack.value)) then
			table.insert(reticles, mo)
		end
	end, MT_PLAYERRETICULE)

	-- spec anyone on our team when jawz is chasing
	function A_JawzChase(actor, var1, var2)
		if fren.doteamstuff and (fr_friendlyjawz.value or (not fr_teamattack.value)) then
			-- already targetting a teammate?
			if actor.tracer and actor.target.player.frn.team == actor.tracer.player.frn.team then
				FRlog("STOP!", actor.target.player)
				actor.tracer = nil
			end

			local specced = {}
			for p in players.iterate do
				if not p.spectator and p ~= actor.target.player and p.frn.team == actor.target.player.frn.team then
					p.spectator = true
					specced[p] = true
				end
			end

			super(actor, var1, var2)

			for k, v in pairs(specced) do
				k.spectator = false
			end
		else
			super(actor, var1, var2)
		end
	end
end

local function addSPBHooks()
	FRlog("Hooking SPBs")
	-- again, spec teammates
	function A_SPBChase(actor, var1, var2)
		if fren.doteamstuff and (fr_friendlyspb.value or (not fr_teamattack.value)) then
			local specced = {}
			for p in players.iterate do
				if not p.spectator and actor.target and p ~= actor.target.player and p.frn.team == actor.target.player.frn.team then
					p.spectator = true
					specced[p] = true
				end
			end

			super(actor, var1, var2)

			for k, v in pairs(specced) do
				k.spectator = false
			end
		else
			super(actor, var1, var2)
		end
	end
end

-- restock items for boss
local restockitems = {
	[KITEM_SNEAKER] = true,
	[KITEM_ROCKETSNEAKER] = false,
	[KITEM_INVINCIBILITY] = false,
	[KITEM_BANANA] = true,
	[KITEM_EGGMAN] = true,
	[KITEM_ORBINAUT] = true,
	[KITEM_JAWZ] = true,
	[KITEM_MINE] = true,
	[KITEM_BALLHOG] = false,
	[KITEM_SPB] = false,
	[KITEM_GROW] = false,
	[KITEM_SHRINK] = false,
	[KITEM_THUNDERSHIELD] = false,
	[KITEM_HYUDORO] = false,
	[KITEM_POGOSPRING] = false,
	[KITEM_KITCHENSINK] = true,
}

addHook("ThinkFrame", function()
	if not fren.doteamstuff then return end

	if addTeamAttackHooks and fr_teamattack.value == 0 then
		addTeamAttackHooks()
		addTeamAttackHooks = nil
	end
	if addJawzHooks and (fr_friendlyjawz.value == 1 or fr_teamattack.value == 0) then
		addJawzHooks()
		addJawzHooks = nil
	end
	if addSPBHooks and (fr_friendlyspb.value == 1 or fr_teamattack.value == 0) then
		addSPBHooks()
		addSPBHooks = nil
	end

	if leveltime == 5 then
		if fren.bossmode then
			S_StartSound(nil, sfx_frboss)
		else
			S_StartSound(nil, sfx_fmssb0)
			S_StartSound(nil, sfx_fmteam)
		end
	end

	-- boss specs?
	if fren.bossplayer and fren.bossplayer.spectator then fren.bossplayer = false end

	local boss = fren.bossplayer
	for p in players.iterate do
		if p.spectator then
			if fr_crewbattle.value and not fren.bossmode and p.pflags & PF_WANTSTOJOIN
			and fr_crewfill.string == "Spectate" and not findcrew(p) then
				p.pflags = $ & ~PF_WANTSTOJOIN
				chatprintf(p, "\131*Your name or clan did not match any crew names.", true)
			end
			p.frn.team = 0
			continue
		end

		if p.frn.team == 0 then
			print(p.name.." HAS NO TEAM!")
			continue
		end

		local realcolor = realskincolor(p.frn.team)
		if p.skincolor ~= realcolor then
			if leveltime > 1 then CONS_Printf(p, "Your color has been saved.") end
			p.mo.color = realcolor
			p.skincolor = realcolor
		end

		-- to avoid confusing people after our insane jawz hack,
		-- spawn a reticle on a player who CAN be targeted
		if (fr_friendlyjawz.value or not fr_teamattack.value)
		and p.kartstuff[k_itemtype] == KITEM_JAWZ and p.kartstuff[k_itemheld]
		and p.kartstuff[k_lastjawztarget] ~= -1
		-- K_KartPlayerAfterThink won't leave a stale player in lastjawztarget
		and players[p.kartstuff[k_lastjawztarget]].skincolor == p.skincolor then
			-- not this shit again
			local specced = {}
			for q in players.iterate do
				if not q.spectator and q ~= p and q.frn.team == p.frn.team then
					q.spectator = true
					specced[q] = true
				end
			end

			local target = K_FindJawzTarget(p.mo, p)

			for q in pairs(specced) do q.spectator = false end

			if target then
				local ret = P_SpawnMobj(target.mo.x, target.mo.y, target.mo.z, MT_PLAYERRETICULE)
				--ret.old_x = targ.mo.old_x -- i wish...
				--ret.old_y = targ.mo.old_y
				--ret.old_z = targ.mo.old_z
				ret.target = target.mo
				ret.frame = $ | (leveltime % 10) / 2
				ret.tics = 1
				ret.color = p.skincolor
			end
		end

		if fren.bossmode and boss then -- the bossmode block
			if p == boss then
				-- pity item
				if fren.dobossprotect and p.kartstuff[k_spinouttimer] < TICRATE then
					fren.dobossprotect = false
					if p.kartstuff[k_itemtype] == 0 and p.kartstuff[k_position] ~= 1 then
						p.kartstuff[k_itemtype] = KITEM_SNEAKER
						p.kartstuff[k_itemamount] = 1
						bossflash()
						fren.dobossrestock = false
					end
				end
				-- start item
				if leveltime == 5*TICRATE then
					p.kartstuff[k_itemtype] = KITEM_KITCHENSINK
					p.kartstuff[k_itemamount] = 3
					bossflash()
					fren.dobossrestock = false
				end
				-- restock
				if fren.dobossrestock and p.kartstuff[k_position] ~= 1 and p.frn.lastframeitem == 0
				and restockitems[p.kartstuff[k_itemtype]] then
					p.kartstuff[k_itemamount] = $ + ($ == 1 and 2 or 4) -- if itemamount == 1, only add 2
					FRlog("Restocked", p)
					fren.dobossrestock = false
				elseif p.kartstuff[k_itemamount] == 0 then
					fren.dobossrestock = true
				end
			end

			-- karma roulette
			if p.kartstuff[k_roulettetype] ~= 2 then -- not eggman item
				if p == boss then
					p.kartstuff[k_roulettetype] = (p.kartstuff[k_position] ~= 1 or G_BattleGametype()) and 1 or 0
				elseif p ~= boss and not G_BattleGametype() then
					p.kartstuff[k_roulettetype] = p.kartstuff[k_position] > boss.kartstuff[k_position] and 1 or 0
				end
			end

			-- replace items for world players
			if p ~= boss and p.frn.lastframeitem == 0 and p.kartstuff[k_itemtype] > 0 then
				-- replace grow, invincibility and rocket sneakers
				if (p.kartstuff[k_position] <= boss.kartstuff[k_position] or fr_nopoweritems.value)
				and (p.kartstuff[k_itemtype] == KITEM_GROW or p.kartstuff[k_itemtype] == KITEM_INVINCIBILITY or p.kartstuff[k_itemtype] == KITEM_ROCKETSNEAKER) then
					p.kartstuff[k_itemtype] = KITEM_SNEAKER
					FRlog("Replacing power item", p)
				end
				-- maximum of 1 jawz if you're ahead of the boss
				if p.kartstuff[k_position] <= boss.kartstuff[k_position]
				and p.kartstuff[k_itemtype] == KITEM_JAWZ and p.kartstuff[k_itemamount] > 1 then
					p.kartstuff[k_itemamount] = 1
					FRlog("Replacing double Jawz", p)
				end
				-- do not allow SPB if boss is not in 1st place
				if boss.kartstuff[k_position] ~= 1 and p.kartstuff[k_itemtype] == KITEM_SPB then
					p.kartstuff[k_itemtype] = KITEM_ROCKETSNEAKER
					FRlog("Replacing SPB", p)
				end
				-- never allow shrink
				if p.kartstuff[k_itemtype] == KITEM_SHRINK then
					p.kartstuff[k_itemtype] = KITEM_ROCKETSNEAKER
					FRlog("Replacing Shrink", p)
				end
			end
			p.frn.lastframeitem = p.kartstuff[k_itemtype]
		end
	end

	for _, mo in pairs(reticles) do
		-- since reticles don't save their source player, but DO save the source's skincolor,
		-- we'll have to take a wild guess based on skincolors
		if mo.target.player.skincolor == mo.color then
			mo.flags2 = $ | MF2_DONTDRAW
		end
	end
	reticles = {}

	if fren.gameover then
		local gottago = false
		for p in players.iterate do
			if p.exiting == 2 then
				gottago = true
				break
			end
		end
		if gottago or exitcountdown == 2 or server.hmfinishtimer == 1 then
			ExitRace()
		end
		return
	end

	calculateScore()

	for _, team in pairs(frteams) do
		team.pcount, team.finished, team.timeovered = 0, 0, 0
	end

	-- count finished players
	for p in players.iterate do
		if not p.spectator then
			frteams[p.frn.team].pcount = $ + 1
			if p.exiting > 0 or (G_BattleGametype() and p.kartstuff[k_bumper] <= 0) then frteams[p.frn.team].finished = $ + 1 end
			if p.pflags & PF_TIMEOVER then frteams[p.frn.team].timeovered = $ + 1 end
		end
	end

	-- count finished teams
	local bestscore = 0
	fren.teamsfinished = 0
	local emptyteams = 0 -- don't count empty teams in race mode
	for k, team in pairs(frteams) do
		bestscore = max($, team.score)
		if team.pcount == team.finished + team.timeovered then
			fren.teamsfinished = $ + 1
		end
		--if team.pcount == 0 then emptyteams = $ + 1 end
	end

	-- get winning team
	local winteam = 0
	local c = 0
	for k, team in pairs(frteams) do
		if team.score == bestscore and team.timeovered ~= team.pcount then
			winteam = k
			c = $ + 1
		end
	end
	fren.winningteam = c == 1 and winteam or 0

	-- fatal KO: all but one team has finished, and the last team has zero score
	-- check for zero score
	local fatal = 0
	for k, team in pairs(frteams) do
		if team.score == 0 then
			fatal = k
			break
		end
	end

	-- now check finished teams
	if fatal and fren.teamsfinished == #frteams - 1
	and not (fren.gameover or fren.blowout or G_BattleGametype()) then
		FRlog("Blowout due to fatal")
		doBlowout(fatal)
		EndRace()
	end

	local timelimitintics = CV_FindVar("timelimit").value * 60 * TICRATE

	-- everyone finished?
	if fren.teamsfinished >= #frteams - (G_BattleGametype() and 1 or emptyteams)
	or (G_BattleGametype() and timelimitintics and timelimitintics < leveltime - starttime) then
		if not fren.gameover then
			if fren.teamsfinished == emptyteams then
				if fren.blowout then
					FRlog("ALREADY DID A BLOWOUT!")
				else
					FRlog("Blowout due to empty teams")
					FRlog("There were "..emptyteams.." empty teams")
					doBlowout(0)
				end
			end
			EndRace()
		end
	end
end)

-- initialize new players
addHook("PlayerSpawn", function(p)
	if fren.doteamstuff then
		if not p.frn then
			InitPlayer(p)
		end
		if not p.spectator then
			if p.frn.team == 0 then
				autoassignteam(p)
			end
			-- may get specced if crewfill is set to spectate
			if not p.spectator then SpawnOverhead(p) end
		end
	end
end)

-- boss leaves?
addHook("PlayerQuit", function(p)
	if p == fren.bossplayer then fren.bossplayer = false end
end)

local wantedreduce = 5*TICRATE
local killpoints = false

-- all sorts of team attack stuff
local function doTeamAttack(target, inflictor, source)
	if fren.doteamstuff and source and source.player and target ~= source.player then
		local splayer = source.player
		if target.frn.team == splayer.frn.team and not splayer.exiting then
			-- warn source
			if fr_teamwarning.value then
				S_StartSoundAtVolume(nil, sfx_s3k50, 255, splayer)
				splayer.frn.teamattacked = leveltime + 2*TICRATE
			end

			-- punish source
			if fr_teamreflect.value then
				S_StartSound(source, sfx_kc3b)
				K_SpawnMineExplosion(source, splayer.skincolor)
				P_DamageMobj(source, nil, nil, 10000)
			end

			-- don't award points for hitting teammates in battle mode
			if G_BattleGametype() then
				killpoints = true -- you cheeky bastard...
				local scoremultiply = 1
				local trapitem = inflictor.type == MT_BANANA or inflictor.type == MT_BANANA_SHIELD
				if not trapitem then
					if K_IsPlayerWanted(target) then
						scoremultiply = 3
					elseif target.kartstuff[k_bumper] == 1 then
						scoremultiply = 2
					end
				end
				-- addplayerscore amount is unsigned...
				if not splayer.exiting then splayer.marescore = $ - scoremultiply end

				if not trapitem then
					splayer.kartstuff[k_wanted] = $ + wantedreduce
					target.kartstuff[k_wanted] = $ + wantedreduce/2
				end
			end
		elseif fren.bossmode and splayer ~= fren.bossplayer and not fren.bossplayer.exiting then
			fren.bossgotemname = teamprefix(splayer.frn.team)..splayer.name
			fren.bossgotemtime = leveltime + TICRATE*3
			fren.bossgotemposition = G_BattleGametype() and -1 or fren.bossplayer.kartstuff[k_position]
			fren.dobossprotect = true

			if fren.bossgotemposition == 1 then
				S_StartSound(nil, sfx_fmpnch)
			else
				S_StartSound(nil, sfx_fmbshc)
			end
		end
	end
end

addHook("PlayerSpin", doTeamAttack)
addHook("PlayerSquish", doTeamAttack)
addHook("PlayerExplode", doTeamAttack)

addHook("MobjSpawn", function(mo)
	if killpoints then
	-- how do we remove an mobj that just spawned without using P_RemoveMobj?
	-- we can't use P_KillMobj or set state to zero because hardcode sets its state immediately afterwards
	-- we can't set MF2_DONTDRAW either because it uses K_MatchGenericExtraFlags
	-- so what do we do?
		mo.flags = $ | MF_NOSECTOR
		killpoints = false
	end
	-- oh yeah, using a local variable for this is perfectly safe because this all takes place in K_SpinPlayer
end, MT_BATTLEPOINT)

-- why don't the karma item boxes save their source player...
local comebacktime = 10*TICRATE
addHook("PreThinkFrame", function()
	if not (fren.doteamstuff and G_BattleGametype()) then return end
	for p in players.iterate do
		local ATTACK_IS_DOWN = (p.cmd.buttons & BT_ATTACK) and not (p.pflags & PF_ATTACKDOWN)
		if p.mo and p.mo.health > 0 and not (p.spectator or p.exiting or SG_MapReset() or p.kartstuff[k_spinouttimer] or p.kartstuff[k_squishedtimer] or p.kartstuff[k_respawn]) then
			// First, the really specific, finicky items that function without the item being directly in your item slot.
			// Karma item dropping
			if ATTACK_IS_DOWN and p.kartstuff[k_comebackmode] == 1 and p.kartstuff[k_comebacktimer] == 0 then
				FRlog("Plop!", p)
				local newitem = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_RANDOMITEM)
				newitem.target = p.mo -- ...this... is literally... the only thing... i needed...
				newitem.threshold = 69 // selected "randomly".
				newitem.flags2 = p.mo.flags2 & MF2_OBJECTFLIP
				newitem.fuse = 15*TICRATE // selected randomly.

				p.kartstuff[k_comebackmode] = 0
				p.kartstuff[k_comebacktimer] = comebacktime
				S_StartSound(p.mo, sfx_s254)
			end
		end
	end
end)

-- stop players from giving item boxes to their enemies
addHook("TouchSpecial", function(item, mo)
	if fren.doteamstuff and item.threshold == 69 and item.target.player.frn.team ~= mo.player.frn.team then
		FRlog("Type 5 parry", mo.player)
		K_DoInstashield(mo.player)
		return true
	end
end, MT_RANDOMITEM)

-- and stop players from team attacking in karma mode
addHook("TouchSpecial", function(item, mo)
	if fren.doteamstuff and G_BattleGametype() then
		local source = item.target.player
		local target = mo.player
		if not (target == source or target.kartstuff[k_bumper] <= 0 or source.exiting or target.exiting
		or source.kartstuff[k_comebacktimer] or source.kartstuff[k_spinouttimer] or source.kartstuff[k_squishedtimer]) then
			-- is the player blowing up a teammate?
			if source.kartstuff[k_comebackmode] ~= 1 and source.frn.team == target.frn.team
				if not fr_teamattack.value then
					FRlog("Type 6 parry", target)
					K_DoInstashield(target)
					return true
				else -- don't award any comeback points
					source.kartstuff[k_comebackpoints] = -1
				end
			end
			-- is the player giving an item to an enemy?
			if source.kartstuff[k_comebackmode] == 1 and source.frn.team ~= target.frn.team
				FRlog("Type 7 parry", target)
				K_DoInstashield(target)
				return true
			end
		end
	end
end, MT_KARMAHITBOX)

-- HUD stuff

local function smallwidth(v, s, f)
	return v.stringWidth(s, f, "small") / 2
end

local function thinwidth(v, s, f)
	return v.stringWidth(s, f, "thin") / 2
end

hud.add(function(v, p) -- AAAAAAAAAAHHHHHHHHHHHHH -- G: ???
	if not fren.doteamstuff then return end

	local dpexiting, dpspeccing, splitindex = 0, 0
	for dp, i in displayplayers.iterate do
		if playerfinished(dp) or (G_BattleGametype() and dp.kartstuff[k_bumper] <= 0 and dp.kartstuff[k_comebacktimer] > 0) then dpexiting = $ + 1 end
		if dp.spectator then dpspeccing = $ + 1 end
		if p == dp then splitindex = i end
	end
	if splitindex == nil then return end

	if fr_debug.value and splitindex == splitscreen then
		if fren.bossmode then
			v.drawString(8, 136, "STOCK "..tostring(fren.dobossrestock))
		end

		v.drawString(8, 144, "TEAMFIN "..fren.teamsfinished)
		v.drawString(88, 144, "WINNING "..fren.winningteam)
		v.drawString(168, 144, "GAMEOVER "..tostring(fren.gameover))
		if not addTeamAttackHooks then v.drawString(284, 144, "HOOK", V_GREENMAP) end
		if not addJawzHooks then v.drawString(284, 136, "HOOK", V_SKYMAP) end
		if not addSPBHooks then v.drawString(284, 128, "HOOK", V_REDMAP) end

		v.drawString(8, 152, "CNT")
		v.drawString(40, 152, "FIN")
		v.drawString(72, 152, "TMO")
		v.drawString(104, 152, "SCORE")
		for i, team in pairs(frteams) do
			v.drawString(8, 152 + i*8, teamprefix(i)..team.pcount)
			v.drawString(40, 152 + i*8, teamprefix(i)..team.finished)
			v.drawString(72, 152 + i*8, teamprefix(i)..team.timeovered)
			v.drawString(104, 152 + i*8, teamprefix(i)..team.score)
		end
	end

	local splitscreen = splitscreen
	local showfinish = (dpexiting > splitscreen - dpspeccing) or (dpspeccing > splitscreen)
	-- if all displayplayers finished, pretend we're 1P only
	if showfinish then
		if splitindex ~= splitscreen then return end
		splitscreen = 0
		splitindex = 0
		p = displayplayers[0]
	end

	local tn = {}
	for k, team in pairs(frteams) do
		tn[k] = teamprefix(k)..team.name
	end

	local vflags = SG_GetSplitscreenFlags(splitindex) | V_SNAPTOTOP | V_ALLOWLOWERCASE
	-- need to center stuff properly on 3P/4P splitscreen
	local xofs = 0
	if splitscreen >= 2 then
		xofs = ((v.width()/v.dupx()) - 320)>>2
		if splitindex & 1 then xofs = -xofs end
		xofs = $ + 80
	end

	local myteam = p.spectator and 1 or p.frn.team

	-- intro
	if leveltime < 10*TICRATE and not p.spectator then
		local lines = {}

		if splitscreen < 2 then
			if fren.bossmode then
				if myteam == 2 then
					lines[1] = "You are "..tn[2].."\x80!"
					lines[2] = "Defeat "..tn[1].."\x80!"
				else
					lines[1] = "Unite with "..tn[1].."\x80!"
					lines[2] = "Take down "..tn[2].."\x80!"
				end
			else
				lines[1] = "You are on "..tn[myteam].."\x80!"
				for i = 1, #tn do
					if i ~= myteam then table.insert(lines, (#lines == 1 and "Defeat " or "and ")..tn[i]) end
				end
				lines[#lines] = $.."\x80!"
			end
		else
			if fren.bossmode then
				if myteam == 2 then
					lines[1] = "You're "..tn[2].."\x80!"
					lines[2] = "Defeat "..tn[1].."\x80!"
				else
					lines[1] = "Join "..tn[1].."\x80!"
					lines[2] = "Beat "..tn[2].."\x80!"
				end
			else
				lines[1] = "You're "..tn[myteam].."\x80!"
				for i = 1, #tn do
					if i ~= myteam then table.insert(lines, (#lines == 1 and "Beat " or "and ")..tn[i]) end
				end
				lines[#lines] = $.."\x80!"
			end
		end

		local font = splitscreen >= 2 and "thin" or "center"
		if splitscreen >= 2 then vflags = $ | V_6WIDTHSPACE end
		v.drawString(160 - xofs - (splitscreen >= 2 and thinwidth(v, lines[1], vflags) or 0), 16, lines[1], vflags, font)
		for k, str in ipairs(lines) do
			if k ~= 1 then v.drawString(160 - xofs - (splitscreen >= 2 and thinwidth(v, str, vflags) or 0), 10 + k*8, str, vflags, font) end
		end

		if splitscreen then return end
		vflags = $ | V_HUDTRANS

		local ty = 25 + #lines * 8
		local morepoints = (fren.battletype == 1 and "Score more points than" or "Outlast")
		local enemyprefix = #tn == 2 and teamprefix(myteam ^^ 3) or "\128"

		local tutorial = G_RaceGametype()
		and "+2 per "..enemyprefix.."enemy\128 passed, +1 for first place"
		or morepoints.." the "..enemyprefix.."other team!\128"..(fren.nobumpers and "" or " +2 per bumper")

		if fren.bossmode then
			if p == fren.bossplayer then
				tutorial = G_RaceGametype()
				and "Your items are supercharged! "..teamprefix(myteam).."Finish 1st\128 to win!"
				or (fren.nobumpers and "" or "You're surrounded by bumpers! ")..morepoints.." your "..enemyprefix.."enemies\128!"
			else
				tutorial = enemyprefix.."BOSS WINS\128 if they "..
				(G_RaceGametype() and "finish 1st" or (fren.battletype == 1 and "score more points" or "survive"))
				.."! Stop them at all costs!"
			end
		end
		v.drawString(160 - smallwidth(v, tutorial, vflags), ty, tutorial, vflags, "small")

		if not (fren.bossmode and p == fren.bossplayer) then
			tutorial = "Team Attack is "..(fr_teamattack.value and "\133ON\128: watch where you throw!" or "\131OFF\128: get up close and personal!")
			v.drawString(160 - smallwidth(v, tutorial, vflags), ty + 5, tutorial, vflags, "small")
		end

		return
	end

	vflags = $ | V_HUDTRANS
	local danger = true
	for k, team in pairs(frteams) do
		if k ~= fren.winningteam and team.score > 0 then
			danger = false
			break
		end
	end

	local teamscores, teamflashing = {}, {}
	for k, team in pairs(frteams) do
		teamscores[k] = teamprefix(k)..team.score
		if k == fren.winningteam and ((leveltime % 10 >= 5 and not danger) or (leveltime % 4 >= 2 and danger)) then
			teamflashing[k] = V_30TRANS -- XOR with V_HUDTRANS to get V_HUDTRANSHALF
		else
			teamflashing[k] = 0
		end
	end

	-- team damage
	if not p.spectator then
		local lastteamattack = p.frn.teamattacked - leveltime
		if lastteamattack > 0 and (lastteamattack < 5*TICRATE/3 or not (leveltime % 2)) then
			v.drawString(160 - xofs, 60, "TEAM DAMAGE!", V_REDMAP|vflags, "center")
		end
	end

	-- battle fade (not battle anymore)
	if fren.gameover then v.fadeScreen(31, 5) end

	if not showfinish then
		-- game hud (team scores only)
		if fren.bossmode and fren.bossplayer then
			local str = teamprefix(2)
			local gottime = fren.bossgotemtime - leveltime

			if G_RaceGametype() then
				if p == fren.bossplayer and not fren.bossplayer.exiting then
					local bossremaining = fren.bossplayer.kartstuff[k_position] - 1
					if bossremaining > 0 then
						str = $.."Pass "..bossremaining..(splitscreen and "!" or " to win!")
					else
						str = $..(splitscreen and "Go!" or "Stay ahead!")
					end
				else
					str = $..prettyposition[fren.bossplayer.kartstuff[k_position]]..(splitscreen and "" or " place")
				end
			else
				str = $..(fren.battletype == 1 and fren.bossplayer.marescore.." points" or fren.bossplayer.kartstuff[k_bumper].." bumpers")
			end

			if not splitscreen then
				v.drawString(160 - xofs, 12, str, vflags ^^ teamflashing[2], "center")
			end

			vflags = $ | V_6WIDTHSPACE
			local bossname = splitscreen >= 2 and teamprefix(2)..fren.bossplayer.name or tn[2]
			if gottime > 0 then
				bossname = fren.bossgotemname..(fren.bossgotemposition == 1 and " \128LANDS A MIRACLE HIT!" or " \128NAILED THE BOSS!")
				if gottime >= 5*TICRATE/2 and leveltime % 2 then return end -- you can get away with some nasty returns if you put stuff in the right order
			elseif splitscreen then
				xofs = $ + v.stringWidth(str, vflags)/2
				v.drawString(162 - xofs + thinwidth(v, bossname, vflags), 3, str, vflags ^^ teamflashing[2])
			end
			v.drawString(160 - xofs - thinwidth(v, bossname, vflags), 2, bossname, vflags, "thin")
		else
			local scoreadd = p.spectator and "" or teamprefix(myteam).."+"..p.frn.personalscore
			local yofs = 2
			vflags = $ | V_6WIDTHSPACE

			if splitscreen < 2 then
				local space = 4
				for i = 1, #tn do
					while v.stringWidth(tn[i], vflags, "thin") >= 140 do
						-- don't care, this is the last loop
						tn[i] = $:sub(1, -2)
					end
					local fl = vflags ^^ teamflashing[i]
					local sp = i == myteam and space or -space
					local y = i ~= myteam and yofs or 2
					local width = splitscreen and v.stringWidth(tn[i], fl, "thin") + 2 or 0
					if i ~= myteam then width = -$ end

					-- team name
					v.drawString(160 - sp, y, tn[i], fl, i == myteam and "thin-right" or "thin")
					if splitscreen then y = $ - 9 end
					-- score
					v.drawString(160 - sp - width, y+10, teamscores[i], fl, i == myteam and "right" or "left")
					-- personal score
					if i == myteam and not p.spectator then
						v.drawString(156 - sp - v.stringWidth(teamscores[i]) - (splitscreen and v.stringWidth(tn[i], fl, "thin")), y+10, scoreadd, V_30TRANS ^^ vflags, "right")
					end
					if i ~= myteam then yofs = $ + (splitscreen and 9 or 18) end
				end
			else
				local space = 1
				for i = 1, #tn do
					while v.stringWidth(tn[i], vflags, "thin") >= 64 do
						-- don't care, this is the last loop
						tn[i] = $:sub(1, -2)
					end
					local fl = vflags ^^ teamflashing[i]
					local sp = i == myteam and space or -space
					local y = i ~= myteam and yofs or 2

					-- team name
					local str = i == myteam and teamscores[i].." "..tn[i] or tn[i].." "..teamscores[i]
					v.drawString(160 - sp - xofs, y, str, fl, i == myteam and "thin-right" or "thin")
					-- personal score
					if i == myteam and not p.spectator then
						v.drawString(150 - xofs, y+10, scoreadd, V_30TRANS ^^ vflags, "thin-right")
					end
					if i ~= myteam then yofs = $ + 10 end
				end
			end
		end
	else -- finish hud
		local maxwidth = 320 / #tn

		-- tip or winner
		if fren.gameover then
			vflags = V_HUDTRANS | V_SNAPTOTOP | V_ALLOWLOWERCASE
			local savior = fren.savedtheworld
			if fren.fatalko then
				if leveltime % 4 >= 2 then
					v.drawString(160, 30, teamprefix(fren.winningteam).."FATAL KO", vflags, "center")
				end
			elseif savior then
				local lazyflash = (leveltime % 2) and "\128" or ""
				v.drawString(160, 30, teamprefix(savior.frn.team)..savior.name..lazyflash.." saved "..frteams[savior.frn.team].name.."!", vflags, "center")
			elseif fren.winningteam > 0 then
				v.drawString(160, 30, tn[fren.winningteam].." wins!", vflags, "center")
			else
				v.drawString(160, 30, "what", vflags, "center")
			end
		else
			vflags = V_HUDTRANS | V_SNAPTOTOP | V_ALLOWLOWERCASE
			local helpfuladvicetext = "\131TIP: \128 "..FRtips[fren.helpfuladvice].first
			v.drawString(160 - smallwidth(v, helpfuladvicetext, vflags), 30, helpfuladvicetext, vflags, "small")

			local helpfuladvicetexttwo = FRtips[fren.helpfuladvice].second
			v.drawString(160 - smallwidth(v, helpfuladvicetexttwo, vflags), 35, helpfuladvicetexttwo, vflags, "small")
		end

		-- sort players by score
		local sortedplayers = {}
		for q in players.iterate do
			if not (q.spectator or (q.pflags & PF_TIMEOVER)) then
				table.insert(sortedplayers, q)
			end
		end
		table.sort(sortedplayers, function(a, b)
			if playerfinished(a) ~= playerfinished(b) then
				return playerfinished(a)
			end
			return a.frn.personalscore > b.frn.personalscore
		end)

		-- now draw player names
		local offsets = {}
		for i = 1, #tn do offsets[i] = 0 end

		for _, q in ipairs(sortedplayers) do
			vflags = V_HUDTRANS | V_SNAPTOTOP | V_6WIDTHSPACE | V_ALLOWLOWERCASE
			if fren.bossmode and q == fren.bossplayer then
				vflags = $ | V_REDMAP * (leveltime & (fren.winningteam == 2 and 2 or 4) and 1 or 0)
			elseif not playerfinished(q) then
				vflags = ($ | V_GRAYMAP) ^^ V_30TRANS -- becomes V_HUDTRANSHALF
			end
			local tempname = q.name
			if q == fren.savedtheworld then
				if leveltime & 1 then vflags = $ | V_YELLOWMAP end
				if leveltime % TICRATE >= TICRATE/2 then
					tempname = "CLUTCH!"
				end
			end

			if fren.bossmode then
				if fren.bossplayer and q.kartstuff[k_position] <= fren.bossplayer.kartstuff[k_position] then
					v.drawString(155, 41 + offsets[1], teamprefix(q.frn.team)..tempname, vflags, "thin-right")
					v.drawString(165, 41 + offsets[1], teamprefix(q.frn.team)..prettyposition[q.kartstuff[k_position]], vflags, "thin")
					offsets[1] = $ + 10
				end
			else
				if #tn == 2 then
					if q.frn.team == myteam then
						v.drawString(155, 41 + offsets[q.frn.team], teamprefix(q.frn.team)..tempname.." - "..q.frn.personalscore, vflags, "thin-right")
					else
						v.drawString(165, 41 + offsets[q.frn.team], teamprefix(q.frn.team)..q.frn.personalscore.." - "..tempname, vflags, "thin")
					end
				else
					while v.stringWidth(tempname, vflags, "thin") >= maxwidth - 12 do
						tempname = $:sub(1, -2)
					end
					local str = teamprefix(q.frn.team)..tempname.." "..q.frn.personalscore
					v.drawString((q.frn.team * maxwidth) - maxwidth/2 - thinwidth(v, str, vflags), 41 + offsets[q.frn.team], str, vflags, "thin")
				end
				offsets[q.frn.team] = $ + 10
			end
		end

		if fren.bossmode then return end

		-- now draw the team names
		vflags = V_HUDTRANS | V_SNAPTOTOP | V_6WIDTHSPACE | V_ALLOWLOWERCASE
		local highestofs = 0
		for _, v in pairs(offsets) do
			highestofs = max($, v)
		end

		if #tn == 2 then
			v.drawString(155, highestofs + 39, "----------------------------", vflags, "thin-right")
			v.drawString(155, highestofs + 47, tn[myteam].." - "..teamscores[myteam], vflags ^^ teamflashing[myteam], "thin-right")
			v.drawString(165, highestofs + 39, "----------------------------", vflags, "thin")
			v.drawString(165, highestofs + 47, teamscores[myteam ^^ 3].." - "..tn[myteam ^^ 3], vflags ^^ teamflashing[myteam ^^ 3], "thin")
		else
			local separator = ""
			while v.stringWidth(separator, vflags, "thin") < maxwidth - 12 do
				separator = $.."-"
			end
			for i = 1, #tn do
				v.drawString((i * maxwidth) - maxwidth/2 - thinwidth(v, separator, vflags), highestofs + 39, separator, vflags, "thin")
				while v.stringWidth(tn[i], vflags, "thin") >= maxwidth - 12 do
					tn[i] = $:sub(1, -2)
				end
				tn[i] = tn[i].." "..teamscores[i]
				v.drawString((i * maxwidth) - maxwidth/2 - thinwidth(v, tn[i], vflags), highestofs + 47, tn[i], vflags ^^ teamflashing[i], "thin")
			end
		end
	end
end)

--[[
COM_AddCommand("timeover", function(p, target)
	target = tonumber($)
	doTimeOver(players[target])
end)

COM_AddCommand("checkpoint", function(p, target)
	target = tonumber($)
	players[target].starpostnum = INT32_MAX
end)
--]]
